
proc ensure_lib { lib } { if ![file isdirectory $lib] { vlib $lib} }

set CUSTOM_DO_FILE  "wave.do"
set LIB_DIR         ./libs
set WORK_DIR        work

ensure_lib          $LIB_DIR
ensure_lib          [subst $LIB_DIR/$WORK_DIR/]
vmap work           [subst $LIB_DIR/$WORK_DIR/]

set TOP AEAD_TB

alias compile_vhdl_src {
	vcom -quiet -work work                            "../src_rtl/reg_n.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_SQ_SCL_2.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_SQ_2.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_SCL_2.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_MUL_SCL_2_TImc.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_MUL_SCL_2_TImb.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_MUL_SCL_2_TIma.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_MUL_2_TImc.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_MUL_2_TImb.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_MUL_2_TIma.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_INV_2.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_SQ_SCL_4.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_MUL_4_TIa.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_INV_4_TIa.vhd"
	vcom -quiet -work work                            "../src_rtl/MUL_MX.vhd"
	vcom -quiet -work work                            "../src_rtl/MUL_INVX.vhd"
	vcom -quiet -work work                            "../src_rtl/GF_INV_GF8_TIa.vhd"
	vcom -quiet -work work                            "../src_rtl/AES_mulx03.vhd"
	vcom -quiet -work work                            "../src_rtl/AES_mulx02.vhd"
	vcom -quiet -work work                            "../src_rtl/MixCol.vhd"
	vcom -quiet -work work                            "../src_rtl/AES_Sbox_TI.vhd"
	vcom -quiet -work work                            "../src_rtl/AES_pkg.vhd"
	vcom -quiet -work work                            "../src_rtl/and_3TI.vhd"
	vcom -quiet -work work                            "../src_rtl/datapath.vhd"
	vcom -quiet -work work                            "../src_rtl/controller.vhd"
	vcom -quiet -work work                            "../src_rtl/GF128_seq_mul_TI.vhd"
	vcom -quiet -work work                            "../src_rtl/AES.vhd"
	vcom -quiet -work work                            "../src_rtl/design_pkg.vhd"
	vcom -quiet -work work                            "../src_rtl/AEAD_pkg.vhd"
	vcom -quiet -work work                            "../src_rtl/CipherCore_Datapath_8bit.vhd"
	vcom -quiet -work work                            "../src_rtl/CipherCore_Controller_8bit.vhd"
	vcom -quiet -work work                            "../src_rtl/StepDownCountLd.vhd"
	vcom -quiet -work work                            "../src_rtl/RegN.vhd"
	vcom -quiet -work work                            "../src_rtl/RegLd.vhd"
	vcom -quiet -work work                            "../src_rtl/Reg.vhd"
	vcom -quiet -work work                            "../src_rtl/GeneralComponents_pkg.vhd"
	vcom -quiet -work work                            "../src_rtl/CAESAR_LWAPI_pkg.vhd"
	vcom -quiet -work work                            "../src_rtl/CipherCore_8bit.vhd"
	vcom -quiet -work work                            "../src_rtl/PreProcessor_mod.vhd"
	vcom -quiet -work work                            "../src_rtl/PostProcessor_mod.vhd"
	vcom -quiet -work work                            "../src_rtl/fwft_fifo.vhd"
	vcom -quiet -work work                            "../src_rtl/AEAD.vhd"
	vcom -quiet -work work                            "../src_rtl/AEAD_Wrapper.vhd"
}

alias compile_vhdl_tb {
	vcom -quiet -work work                            "../src_tb/std_logic_1164_additions.vhd"
	vcom -quiet -work work                            "../src_tb/AEAD_TB.vhd"
}

alias run_sim {
    set run_do_file [file isfile $CUSTOM_DO_FILE]
    if {$run_do_file == 1} {
        vsim -novopt -t ps -L work $TOP -do $CUSTOM_DO_FILE 
    } else {
        vsim -novopt -t ps -L work $TOP 
    }
    add wave -noupdate -group sim -radix hexadecimal $TOP/*
    add wave -noupdate -group core -radix hexadecimal $TOP/uut/*
    run 20 us
}

alias ld {
    set stall 0
    compile_vhdl_src    
    compile_vhdl_tb
    run_sim
}

alias ldv {
    set stall 0
    compile_vlog_src    
    compile_vlog_tb
    run_sim
}

alias h {
  echo "List Of Command Line Aliases"
  echo
  echo [subst "ld   -- Run Testbench (Vhdl: $TOP)"]
  echo
  echo [subst "ldv  -- Run Testbench (Vlog: $TOP)"]
  echo
}
h
